/****************************************************************************
 *
 *                               IBM INC.
 *
 *                           PROPRIETARY DATA
 *
 * Licensed Material - Property Of IBM
 *
 * "Restricted Materails of IBM"
 *
 * IBM Informix Client SDK
 *
 * (c)  Copyright IBM Corporation 2005. All rights reserved.
 *
 *  Title:	sqlproto.h
 *  Description:
 *		Prototypes of user functions exported by ISQLIxxx.DLL 
 *
 ***************************************************************************
 */

#ifndef _SQLPROTO
#define _SQLPROTO
#ifdef __cplusplus
extern "C" {
#endif

int __cdecl bycmpr(char *s1,char *s2,int cnt);
void __cdecl bycopy(char *s1,char *s2,int n);
void __cdecl byfill(char *s,int n,char c);
int __cdecl byleng(char *beg,int cnt);
int __cdecl decadd(struct decimal *n1,struct decimal *n2,struct decimal *n3);
int __cdecl deccmp(struct decimal *n1,struct decimal *n2);
void __cdecl deccopy(struct decimal *n1,struct decimal *n2);
int __cdecl deccvasc(char *cp,int len,struct decimal *np);
int __cdecl deccvdbl(double dbl,struct decimal *np);
int __cdecl deccvint(int in,struct decimal *np);
int __cdecl deccvlong(long lng,struct decimal *np);
int __cdecl decdiv(struct decimal *n1,struct decimal *n2,struct decimal *n3);
char * __cdecl dececvt(struct decimal *np,int ndigit,int *decpt,int *sign);
char * __cdecl decfcvt(struct decimal *np,int ndigit,int *decpt,int *sign);
int __cdecl decmul(struct decimal *n1,struct decimal *n2,struct decimal *n3);
void __cdecl decround(struct decimal *np,int dec_round);
int __cdecl decsub(struct decimal *n1,struct decimal *n2,struct decimal *n3);
int __cdecl dectoasc(struct decimal *np,char *cp,int len,int right);
int __cdecl dectodbl(struct decimal *np,double *dblp);
int __cdecl dectoint(struct decimal *np,int *ip);
int __cdecl dectolong(struct decimal *np,long *lngp);
void __cdecl dectrunc(struct decimal *np,int trunc);
void __cdecl dtcurrent(struct dtime *d);
int __cdecl dtcvasc(char *str,struct dtime *d);
int __cdecl ifx_dtcvasc(char *str,struct dtime *d, char db_century);
int __cdecl dtcvfmtasc(char *input,char *fmt,struct dtime *d);
int __cdecl ifx_dtcvfmtasc(char *input,char *fmt,struct dtime *d, char db_century);
int __cdecl dtextend(struct dtime *id,struct dtime *od);
int __cdecl dttoasc(struct dtime *d,char *str);
int __cdecl dttofmtasc(struct dtime *d,char *output,int str_len,char *fmtstr);
int __cdecl ifx_dttofmtasc(struct dtime *d,char *output,int str_len,char *fmtstr, char db_century);
int __cdecl incvasc(char *str,struct intrvl *i);
int __cdecl incvfmtasc(char *input,char *fmt,struct intrvl *intvl);
int __cdecl intoasc(struct intrvl *i,char *str);
int __cdecl intofmtasc(struct intrvl *i,char *output,int str_len,char *fmtstr);
void __cdecl ldchar(char *from,int count,char *to);
int __cdecl rdatestr(long jdate,char *str);
int __cdecl rdayofweek(long date);
int __cdecl rdefmtdate(long *pdate,char *fmtstring,char *input);
int __cdecl ifx_defmtdate(long *pdate,char *fmtstring,char *input, char db_century);
void __cdecl rdownshift(char *s);
int __cdecl rfmtdate(long date,char *fmtstring,char *result);
int __cdecl rfmtdec(struct decimal *dec,char *format,char *outbuf);
int __cdecl rfmtdouble(double dvalue,char *format,char *outbuf);
int __cdecl rfmtlong(long lvalue,char *format,char *outbuf);
int __cdecl rget_lmsg(long msgnum,char *s,int maxsize,int *msg_length);
int __cdecl rgetlmsg(long msgnum,char *s,int maxsize,int *msg_length);
int __cdecl rgetmsg(int msgnum,char *s,int maxsize);
int __cdecl risnull(int vtype,char *pcvar);
int __cdecl rjulmdy(long jdate,short *mdy);
int __cdecl rleapyear(int year);
int __cdecl rmdyjul(short *mdy,long *jdate);
int __cdecl rsetnull(int vtype,char *pcvar);
int __cdecl rstrdate(char *str,long *jdate);
int __cdecl ifx_strdate(char *str,long *jdate, char db_century);
void __cdecl rtoday(long *today);
#ifdef WIN64
__int64 __cdecl rtypalign(__int64 offset,int type);
#else
int __cdecl rtypalign(int offset,int type);
#endif
int __cdecl rtypmsize(int type,int len);
char * __cdecl rtypname(int type);
int __cdecl rtypwidth(int type,int len);
void __cdecl rupshift(char *s);
int __cdecl sqlexit(void);
void __cdecl stchar(char *from,char *to,int count);
int __cdecl stcmpr(char *s1,char *s2);
int __cdecl rstod(char *str,double *val);
int __cdecl rstoi(char *s,int *val);
int __cdecl rstol(char *s,long *val);
int __cdecl sqgetdbs(int *ret_fcnt,char **fnames ,int fnsize,char *farea,int fasize);
int __cdecl sqlbreak(void);
int __cdecl sqlbreakcallback(long timeout,void (*callback)(int));
int __cdecl ifx_pam_callback(mint (*callbackfunc_ptr)(char *challenge, char *response, mint msg_style));
int __cdecl sqldetach(void);
int __cdecl sqldone(void);
int __cdecl sqlstart(void);
int __cdecl dtaddinv(struct dtime *d,struct intrvl *i,struct dtime *r);
int __cdecl dtsub(struct dtime *d1,struct dtime *d2,struct intrvl *i);
int __cdecl dtsubinv(struct dtime *d,struct intrvl *i,struct dtime *r);
int __cdecl invdivdbl(struct intrvl *iv,double dbl,struct intrvl *ov);
int __cdecl invdivinv(struct intrvl *i1,struct intrvl *i2,double *res);
int __cdecl invextend(struct intrvl *i,struct intrvl *o);
int __cdecl invmuldbl(struct intrvl *iv,double dbl,struct intrvl *ov);
int __cdecl ifx_to_gl_datetime(char *source_str, char *target_str, int maxlen);
void * __cdecl GetConnect ( void );
void * __cdecl SetConnect ( void *NewConInfo );
void * __cdecl ReleaseConnect ( void *NewConInfo );
int __cdecl deccvflt(double source, struct decimal *destination);
int __cdecl dectoflt(struct decimal *source, float *destination);
char * __cdecl ifx_getenv(char *env_name);
int __cdecl ifx_putenv(const char *env_name);
int __cdecl _infxcexp(int RtnNum, void * RtnAddr, int OptParm);
void __cdecl SqlFreeMem( void * MemAddr, int FreeType );
char * __cdecl ifx_getcur_conn_name(void);

int __cdecl ifx_int8cmp(struct ifx_int8 *op1, struct ifx_int8 *op2);
int __cdecl ifx_int8cvlong(long lng, struct ifx_int8 *int8p);
int __cdecl ifx_int8tolong(struct ifx_int8 *int8p, long *lngp);
int __cdecl ifx_int8cvint(int in, struct ifx_int8 *int8p);
int __cdecl ifx_int8toint(struct ifx_int8 *int8p, int *intp);
int __cdecl ifx_int8toint2(struct ifx_int8 *int8p,short *int2p);
int __cdecl ifx_int8toint4(struct ifx_int8 *int8p,long *int4p);
int __cdecl ifx_int8cvasc(char *cp, int len, struct ifx_int8 *int8p);
int __cdecl ifx_int8toasc(struct ifx_int8 *int8p, char *cp, int len);
int __cdecl ifx_int8cvdec(struct decimal *decp, struct ifx_int8 *int8p);
int __cdecl ifx_int8todec(struct ifx_int8 *int8p, struct decimal *decp);
int __cdecl ifx_int8cvdbl(double dbl, struct ifx_int8 *int8p);
int __cdecl ifx_int8todbl(struct ifx_int8 *int8p, double *dblp);
int __cdecl ifx_int8cvflt(double flt, struct ifx_int8 *int8p);
int __cdecl ifx_int8toflt(struct ifx_int8 *int8p, float *fltp);
int __cdecl deccvint8(struct ifx_int8 *int8p, struct decimal *decp);
int __cdecl ifx_int8sub(struct ifx_int8 *int8op1, struct ifx_int8 *int8op2, struct ifx_int8 *int8result);
int __cdecl ifx_int8add(struct ifx_int8 *int8op1, struct ifx_int8 *int8op2, struct ifx_int8 *int8result);
int __cdecl ifx_int8mul(struct ifx_int8 *int8op1, struct ifx_int8 *int8op2, struct ifx_int8 *int8result);
int __cdecl ifx_int8div(struct ifx_int8 *int8op1, struct ifx_int8 *int8op2, struct ifx_int8 *int8result);
void __cdecl ifx_int8copy(struct ifx_int8 *sint8p, struct ifx_int8 *dint8p);
void __cdecl ifx_getserial8(struct ifx_int8 *int8p);

int __cdecl ifx_cl_dealloc(struct _ifx_collection_struct **collection);
long __cdecl ifx_get_row_xid(struct _ifx_collection_struct *collp, int *colnum);
char * __cdecl ifx_get_row_extended_name(struct _ifx_collection_struct *collp);
char * __cdecl ifx_get_msg_param(void);

int __cdecl ifx_var_flag(void **variable, short alloc_flag);
int __cdecl ifx_var_alloc(void **variable, long size);
int __cdecl ifx_var_dealloc(void **variable);
int __cdecl ifx_var_freevar(void **variable);
int __cdecl ifx_var_setdata(void **variable, char *data, long size);
int __cdecl ifx_var_isnull(void **variable);
int __cdecl ifx_var_setnull(void **variable, int flag);
int __cdecl ifx_var_setlen(void **variable, long size);
void * __cdecl ifx_var_getdata(void **variable);
int __cdecl ifx_var_init(void **variable);
int __cdecl ifx_var_getlen(void **variable);
int __cdecl ifx_lvar_alloc(int alloc);

/*
 * Set of ifx_lo_* accessors for opaque data types:
 *	- ifx_lo_create_spec_t
 *	- ifx_lo_stat_t
 *
 * See also: locator.h for description of possible values for arguments 
 */

/* smartblob create spec SET accessors: */
int __cdecl ifx_lo_specset_flags(ifx_lo_create_spec_t *cspec, int flags);
int __cdecl ifx_lo_specset_def_open_flags(ifx_lo_create_spec_t *cspec, int def_open_flags);
int __cdecl ifx_lo_specset_estbytes(ifx_lo_create_spec_t *cspec, ifx_int8_t *size);
int __cdecl ifx_lo_specset_maxbytes(ifx_lo_create_spec_t *cspec, ifx_int8_t *size);
int __cdecl ifx_lo_specset_extsz(ifx_lo_create_spec_t *cspec, int n);
int __cdecl ifx_lo_specset_sbspace(ifx_lo_create_spec_t *cspec, const char *str);
  
/* smartblob create spec GET accessors: */
int __cdecl ifx_lo_specget_flags(ifx_lo_create_spec_t *cspec);
int __cdecl ifx_lo_specget_def_open_flags(ifx_lo_create_spec_t *cspec);
int __cdecl ifx_lo_specget_estbytes(ifx_lo_create_spec_t *cspec, ifx_int8_t *size);
int __cdecl ifx_lo_specget_maxbytes(ifx_lo_create_spec_t *cspec, ifx_int8_t *size);
int __cdecl ifx_lo_specget_extsz(ifx_lo_create_spec_t *cspec);
int __cdecl ifx_lo_specget_sbspace(ifx_lo_create_spec_t *cspec, char *str, int len);

/* smartblob stat GET accessors: */
int __cdecl ifx_lo_stat_size(ifx_lo_stat_t *lostat, ifx_int8_t *size);
int __cdecl ifx_lo_stat_uid(ifx_lo_stat_t *lostat);
int __cdecl ifx_lo_stat_atime(ifx_lo_stat_t *lostat);
int __cdecl ifx_lo_stat_mtime_sec(ifx_lo_stat_t *lostat);
int __cdecl ifx_lo_stat_mtime_usec(ifx_lo_stat_t *lostat);
int __cdecl ifx_lo_stat_ctime(ifx_lo_stat_t *lostat);
int __cdecl ifx_lo_stat_refcnt(ifx_lo_stat_t *lostat);
ifx_lo_create_spec_t * __cdecl ifx_lo_stat_cspec(ifx_lo_stat_t *lostat);

/* smartblob spec and stat destructors: */
int __cdecl ifx_lo_spec_free(ifx_lo_create_spec_t *cspec);
int __cdecl ifx_lo_stat_free(ifx_lo_stat_t *lostat);
/*
 * Set of ifx_lo_ functions for support of Large Objects
 */
int __cdecl ifx_lo_col_info(char *column_name,ifx_lo_create_spec_t *create_spec);
int __cdecl ifx_lo_def_create_spec(ifx_lo_create_spec_t **cspec);
int __cdecl ifx_lo_create(ifx_lo_create_spec_t *create_spec, int flags, ifx_lo_t *loptr, int *error);
int __cdecl ifx_lo_open(ifx_lo_t *loptr, int flags, int *error);
int __cdecl ifx_lo_close(int lofd);
int __cdecl ifx_lo_seek(int lofd, ifx_int8_t *off, int whence, ifx_int8_t *seek_pos);
int __cdecl ifx_lo_tell(int lofd, ifx_int8_t *seek_pos);
int __cdecl ifx_lo_truncate(int lofd, ifx_int8_t *off);
int __cdecl ifx_lo_filename(ifx_lo_t *loptr, char *fname, char *result, int result_buffer_nbytes);
int __cdecl ifx_lo_alter(ifx_lo_t *loptr, ifx_lo_create_spec_t *create_spec);
int __cdecl ifx_lo_stat(int lofd, ifx_lo_stat_t **lostat);
int __cdecl ifx_lo_read(int lofd, char *buf, int nbytes, int *error);
int __cdecl ifx_lo_readwithseek(int lofd, char *buf, int nbytes, ifx_int8_t *off, int whence, int *error);
int __cdecl ifx_lo_write(int lofd, char *buf, int nbytes, int *error);
int __cdecl ifx_lo_writewithseek(int lofd, char *buf, int nbytes, ifx_int8_t *off, int whence, int *error);
int __cdecl ifx_lo_copy_to_lo(int lofd, char *fname, int flags);
int __cdecl ifx_lo_copy_to_file(ifx_lo_t *loptr, char *fname, int flags, char *result);
int __cdecl ifx_lo_release(ifx_lo_t *loptr);
int __cdecl ifx_lo_to_buffer(struct ifx_lo_ts *lo_handle,int size_limit,char **buffer ,int *error);
int __cdecl ifx_lo_from_buffer(struct ifx_lo_ts *lo_handle,int size,char *buffer,int *error);
int __cdecl ifx_lo_lock(int lofd, ifx_int8_t *off, int whence, ifx_int8_t *range, int lockmode);
int __cdecl ifx_lo_unlock(int lofd, ifx_int8_t *off, int whence, ifx_int8_t *range);

int __cdecl ifx_xactevent(void *);
int __cdecl ifx_getserowner(char *serowner);

void *__cdecl ifx_alloc_conn_user(char *username,char *passwd);    
void __cdecl ifx_free_conn_user(struct ifx_connect_struct **conn);
void *__cdecl ifx_alloc_conn_cred(void *cred);                     
void __cdecl ifx_free_conn_cred(struct ifx_connect_struct **conn);
int __cdecl ifx_isius(void);
int __cdecl ifx_cl_card(struct _ifx_collection_struct *colt, int *isnull);
char * __cdecl	sqli_server_version(void);
int    __cdecl	ldcollection(char *cp, ifx_collection_t *collp, mint readsize,
								mint longidver);
void   __cdecl	stcollection(ifx_collection_t *collp, char *start, mint longidver);

#ifdef __cplusplus
}
#endif

#endif /* !_SQLPROTO */
